﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win;

namespace WinGridDemoApp
{
    public partial class HierarchyForm : Form
    {
        public HierarchyForm()
        {
            InitializeComponent();
        }

        #region Variable Declaration
        UltraGridRow lastFirstRow = null;
        Single_Column_Header_At_Top_Creation_Filter gridCreationFilter = null;
        bool isDestinationChildofSource;
        #endregion

        #region Form Load and Other Control Events
        private void Form1_Load(object sender, EventArgs e)
        {
            List<DataClass> gridData = GetGridDummyData();
            DisplayGridData(gridData);
        }

        private void btnReset_Click(object sender, EventArgs e)
        {
            ultraGrid1.DataSource = null;
            List<DataClass> gridData = GetGridDummyData();
            DisplayGridData(gridData);
        }
        #endregion

        #region Methods For Displaying Dummy Data
        private List<DataClass> GetGridDummyData()
        {
            List<DataClass> employee = new List<DataClass>();

            employee.Add(new DataClass(1, "Manager1", 0, " ", 1));
            employee.Add(new DataClass(2, "Employee1", 1, "Manager1", 1));
            employee.Add(new DataClass(3, "Employee2", 2, "Manager1", 1));
            employee.Add(new DataClass(4, "Employee3", 3, "Manager1", 1));
            //employee.Add(new DataClass(5, "Employee4", 1, "Manager1", 1));
            //employee.Add(new DataClass(6, "Employee5", 1, "Manager1", 1));
            //employee.Add(new DataClass(7, "Employee6", 1, "Manager1", 1));
            //employee.Add(new DataClass(8, "Manager2", 0, " ", 2));
            //employee.Add(new DataClass(9, "Employee7", 8, "Manager2", 2));
            //employee.Add(new DataClass(10, "Employee8", 8, "Manager2", 2));
            //employee.Add(new DataClass(11, "Employee9", 8, "Manager2", 1));
            //employee.Add(new DataClass(12, "Employee10", 8, "Manager2", 1));
            //employee.Add(new DataClass(13, "Employee11", 8, "Manager2", 1));
            //employee.Add(new DataClass(14, "Employee12", 8, "Manager2", 1));
            //employee.Add(new DataClass(15, "Employee14", 8, "Manager2", 2));
            //employee.Add(new DataClass(16, "Employee15", 8, "Manager2", 2));
            //employee.Add(new DataClass(17, "Employee16", 8, "Manager2", 2));
            //employee.Add(new DataClass(18, "Employee17", 8, "Manager2", 2));
            //employee.Add(new DataClass(19, "Employee18", 8, "Manager2", 3));
            //employee.Add(new DataClass(20, "Employee19", 8, "Manager2", 3));
            //employee.Add(new DataClass(21, "Employee20", 8, "Manager2", 3));
            //employee.Add(new DataClass(22, "Employee21", 8, "Manager2", 3));
            //employee.Add(new DataClass(23, "Employee23", 8, "Manager2", 3));
            //employee.Add(new DataClass(24, "Employee24", 8, "Manager2", 2));
            //employee.Add(new DataClass(25, "Employee25", 8, "Manager2", 2));
            //employee.Add(new DataClass(26, "Employee26", 8, "Manager2", 1));
            //employee.Add(new DataClass(27, "Employee27", 8, "Manager2", 1));
            //employee.Add(new DataClass(28, "Employee28", 8, "Manager2", 1));
            //employee.Add(new DataClass(29, "Employee29", 8, "Manager2", 1));
            //employee.Add(new DataClass(30, "Employee30", 8, "Manager2", 2));
            //employee.Add(new DataClass(31, "Employee31", 8, "Manager2", 2));
            //employee.Add(new DataClass(32, "Employee32", 8, "Manager2", 2));
            //employee.Add(new DataClass(33, "Employee33", 8, "Manager2", 2));
            //employee.Add(new DataClass(34, "Employee34", 8, "Manager2", 3));
            //employee.Add(new DataClass(35, "Employee35", 8, "Manager2", 3));
            //employee.Add(new DataClass(36, "Employee36", 8, "Manager2", 3));
            //employee.Add(new DataClass(37, "Employee37", 8, "Manager2", 3));
            //employee.Add(new DataClass(38, "Employee38", 8, "Manager2", 3));
            //employee.Add(new DataClass(39, "Employee39", 8, "Manager2", 2));
            //employee.Add(new DataClass(40, "Employee40", 8, "Manager2", 2));
            //employee.Add(new DataClass(41, "Employee41", 8, "Manager2", 1));
            //employee.Add(new DataClass(42, "Employee42", 8, "Manager2", 1));
            //employee.Add(new DataClass(43, "Employee43", 8, "Manager2", 1));
            //employee.Add(new DataClass(44, "Employee44", 8, "Manager2", 1));
            //employee.Add(new DataClass(45, "Employee45", 8, "Manager2", 2));
            //employee.Add(new DataClass(46, "Employee46", 8, "Manager2", 2));
            //employee.Add(new DataClass(47, "Employee47", 8, "Manager2", 2));
            //employee.Add(new DataClass(48, "Employee48", 8, "Manager2", 2));
            //employee.Add(new DataClass(49, "Employee49", 8, "Manager2", 3));
            //employee.Add(new DataClass(50, "Employee50", 8, "Manager2", 3));
            //employee.Add(new DataClass(51, "Employee51", 8, "Manager2", 3));
            //employee.Add(new DataClass(52, "Employee52", 8, "Manager2", 3));
            //employee.Add(new DataClass(53, "Employee53", 8, "Manager2", 3));



            this.ultraGrid1.DisplayLayout.MaxBandDepth = 40;
            List<DataClass> gridData = DataClass.GetEmployees(employee);

            return gridData;
        }

        private void DisplayGridData(List<DataClass> gridData)
        {
            ultraGrid1.DataSource = gridData;
            BandsCollection bands = this.ultraGrid1.DisplayLayout.Bands;

            for (int i = 0; i < bands.Count; i++)
            {
                UltraGridBand band = bands[i];
                band.Override.ExpansionIndicator = ShowExpansionIndicator.CheckOnDisplay;
                band.ColHeadersVisible = false;
                band.Columns[0].CellActivation = Activation.NoEdit;
            }

            this.ultraGrid1.CreationFilter = gridCreationFilter = new Single_Column_Header_At_Top_Creation_Filter(this.ultraGrid1);
            this.SetFirstRowSpacing();
        }

        #endregion

        #region Creation Filter and Events Required For it

        private void SetFirstRowSpacing()
        {
            if (this.ultraGrid1.ActiveRowScrollRegion.FirstRow != null)
            {
                this.SetFirstRowSpacing(this.ultraGrid1.ActiveRowScrollRegion.FirstRow);
            }
        }
        private void SetFirstRowSpacing(UltraGridRow newFirstRow)
        {
            if (lastFirstRow == newFirstRow) return;

            if (lastFirstRow != null)
            {
                lastFirstRow.RowSpacingBefore = 0;
            }

            newFirstRow.RowSpacingBefore = this.gridCreationFilter.GetHeadersHeight();
            lastFirstRow = newFirstRow;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.InterBandSpacing = 0;
            e.Layout.Override.SelectTypeRow = SelectType.SingleAutoDrag;
            e.Layout.Override.SelectTypeCell = SelectType.SingleAutoDrag;
            e.Layout.Override.TipStyleScroll = TipStyle.Hide;
            e.Layout.Rows.ExpandAll(true);
        }

        private void ultraGrid1_AfterSortChange(object sender, Infragistics.Win.UltraWinGrid.BandEventArgs e)
        {
            SetFirstRowSpacing();
        }

        private void ultraGrid1_BeforeRowRegionScroll(object sender, Infragistics.Win.UltraWinGrid.BeforeRowRegionScrollEventArgs e)
        {
            SetFirstRowSpacing(e.NewState.FirstRow);
        }

        private void ultraGrid1_PropertyChanged(object sender, Infragistics.Win.PropertyChangedEventArgs e)
        {
            if (e.ChangeInfo.FindPropId(PropertyIds.ColumnFilters) != null)
            {
                SetFirstRowSpacing();
            }

        }
        private class Single_Column_Header_At_Top_Creation_Filter : IUIElementCreationFilter
        {
            private UltraGridBase grid = null;

            internal Single_Column_Header_At_Top_Creation_Filter(UltraGridBase grid)
            {
                this.grid = grid;
            }

            private class GridHeaderUIElement : Infragistics.Win.UltraWinGrid.HeaderUIElement
            {
                internal GridHeaderUIElement(UIElement parent, HeaderBase context)
                    : base(parent)
                {
                    this.PrimaryContext = context;
                }
            }

            #region Implementation of IUIElementCreationFilter

            internal int GetHeadersHeight()
            {
                return this.grid.DisplayLayout.Bands[0].GetFirstVisibleCol(this.grid.ActiveColScrollRegion, true).Header.Height;
            }

            private void AddBandHeaders(BandHeadersUIElement parent)
            {
                UltraGridColumn column = parent.Band.GetFirstVisibleCol(this.grid.ActiveColScrollRegion, true);

                Rectangle parentRect = parent.Rect;
                int nextHeaderLeft = parentRect.X;

                bool isFirstHeader = true;
                while (null != column)
                {
                    // ------------------------------------------------------------------------------
                    // Until a new build of v2 with public HeaderUIElement taking a header is dropped,
                    // use a derived GridHeaderUIElement class which takes in a header and sets the 
                    // PrimaryContext of the header ui element.
                    // ------------------------------------------------------------------------------
                    //HeaderUIElement colHeaderElem = new HeaderUIElement( parent, column.Header );
                    HeaderUIElement colHeaderElem = new GridHeaderUIElement(parent, column.Header);
                    Rectangle rect = new Rectangle(
                        nextHeaderLeft, parentRect.Y, column.Extent, parentRect.Height);

                    int rowSelectorWidth = 19;
                    if (isFirstHeader)
                        rect.Width += rowSelectorWidth;

                    isFirstHeader = false;
                    colHeaderElem.Rect = rect;
                    nextHeaderLeft = rect.Right;

                    parent.ChildElements.Add(colHeaderElem);

                    column = column.GetRelatedVisibleColumn(VisibleRelation.Next);
                }
            }

            public void AfterCreateChildElements(Infragistics.Win.UIElement parent)
            {
                if (parent is RowColRegionIntersectionUIElement)
                {
                    RowColRegionIntersectionUIElement rcrElem = (RowColRegionIntersectionUIElement)parent;
                    RowScrollRegion rsr = rcrElem.RowScrollRegion;
                    ColScrollRegion csr = rcrElem.ColScrollRegion;

                    UltraGridBand band = this.grid.DisplayLayout.Bands[0];

                    BandHeadersUIElement bandHeadersElem = new BandHeadersUIElement(
                        parent, band, false, this.grid.Rows);

                    Rectangle rect = new Rectangle(
                        1 + band.GetOrigin(BandOrigin.RowSelector) - csr.Position,   // X
                        parent.GetAncestor(typeof(DataAreaUIElement)).Rect.Y,  // Y
                        band.GetExtent(BandOrigin.RowSelector),				   // Width	
                        this.GetHeadersHeight());								   // Height

                    bandHeadersElem.Rect = rect;
                    parent.ChildElements.Add(bandHeadersElem);
                }
                else if (parent is BandHeadersUIElement)
                {
                    this.AddBandHeaders(parent as BandHeadersUIElement);
                }
            }

            public bool BeforeCreateChildElements(Infragistics.Win.UIElement parent)
            {
                return false;
            }

            #endregion
        }

        #endregion

        #region Grid Drag Drop Events
        private void ultraGrid1_SelectionDrag(object sender, CancelEventArgs e)
        {
            UltraGrid uGrid = sender as UltraGrid;
            if (uGrid.Selected.Rows.Count > 0)
            {
                uGrid.DoDragDrop(uGrid.Selected.Rows, DragDropEffects.Move);
            }
            else if (uGrid.Selected.Cells.Count > 0)
            {
                uGrid.DoDragDrop(uGrid.Selected.Cells, DragDropEffects.Move);
            }
        }

        private void ultraGrid1_DragOver(object sender, DragEventArgs e)
        {
            e.Effect = DragDropEffects.Move;
            UltraGrid uGrid = sender as UltraGrid;

            Point pointInGridCoords = uGrid.PointToClient(new Point(e.X, e.Y));
            if (pointInGridCoords.Y < 20)
                // Scroll up.
                uGrid.ActiveRowScrollRegion.Scroll(RowScrollAction.LineUp);
            else if (pointInGridCoords.Y > uGrid.Height - 20)
                // Scroll down.
                uGrid.ActiveRowScrollRegion.Scroll(RowScrollAction.LineDown);
        }

        private void ultraGrid1_DragDrop(object sender, DragEventArgs e)
        {
            try
            {
                UltraGrid uGrid = sender as UltraGrid;

                // Get the position on the grid where the dragged row(s) are to be dropped.
                //get the grid coordinates of the row (the drop zone)
                UIElement uieDestinationElement = uGrid.DisplayLayout.UIElement.ElementFromPoint(uGrid.PointToClient(new Point(e.X, e.Y)));

                //get the row that is the drop zone/or where the dragged row is to be dropped
                UltraGridRow ugrDestinationRow = uieDestinationElement.GetContext(typeof(UltraGridRow), true) as UltraGridRow;

                if (ugrDestinationRow != null)
                {

                    //get the dragged row(s)which are to be dragged to another position in the grid
                    SelectedRowsCollection SelRows = (SelectedRowsCollection)e.Data.GetData(typeof(SelectedRowsCollection)) as SelectedRowsCollection;
                    SelectedCellsCollection SelCells = null;
                    List<UltraGridRow> selRowsList = new List<UltraGridRow>();
                    UltraGridRow selectedRow = null;

                    if (SelRows != null && SelRows.Count > 0)
                    {
                        selectedRow = SelRows[0];
                    }
                    else if (SelRows == null || SelRows.Count == 0)
                    {
                        /*Identify dragged row from selected cells*/
                        SelCells = (SelectedCellsCollection)e.Data.GetData(typeof(SelectedCellsCollection)) as SelectedCellsCollection;
                        if (SelCells != null && SelCells.Count > 0)
                        {
                            selectedRow = SelCells[0].Row;
                        }
                    }

                    if (selectedRow != null)
                    {


                        UltraGridRow ugrSourceRow = selectedRow;
                        DataClass srcListObject = ugrSourceRow.ListObject as DataClass;
                        DataClass destListObject = ugrDestinationRow.ListObject as DataClass;

                        MoveElements(srcListObject, destListObject, ugrSourceRow, ugrDestinationRow);
                        //this.BeginInvoke(new
                        //  GridMethodDelegate(this.DeleteRow), new object[] { 
                        //        ugrSourceRow });
                       
                    }
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("Error Occured\n" + ex.Message, "Error");
            }
        }
        #endregion

        #region Methods Used For Drag Drop Functionality
        private void MoveElements(DataClass srcListObject, DataClass destListObject, UltraGridRow ugrSourceRow, UltraGridRow ugrDestinationRow)
        {
            try
            {
                int newIndex = -1;

                if (ugrSourceRow.HasParent())
                {
                    UltraGridRow SourceParent = ugrSourceRow.ParentRow;
                    UltraGridRow destParentRow = null;

                    if (ugrDestinationRow.HasParent())
                    {
                        destParentRow = ugrDestinationRow.ParentRow;
                    }

                    DataClass OldParentListObject = SourceParent.ListObject as DataClass;
                    DataClass newParentListObject = ugrDestinationRow.ListObject as DataClass;
                    DataClass SourceListObject = ugrSourceRow.ListObject as DataClass;
                    

                    //if destination is not child of source
                    bool bDestChildOfSource = IsSourceContainsDestination(SourceListObject, destListObject);

                    if (!bDestChildOfSource)
                    {
                        newIndex = newParentListObject.Children.Count;
                        newParentListObject.Children.Add(srcListObject);

                        if (destParentRow != null) destParentRow.ChildBands[0].Rows.Refresh(RefreshRow.ReloadData, true, true);

                        ugrDestinationRow.ChildBands[0].Rows.Refresh(RefreshRow.ReloadData, true, true);
                        if (ugrDestinationRow.ChildBands[0].Rows.Count > 0)
                        {
                            ugrDestinationRow.ChildBands[0].Rows[newIndex].Selected = true;
                            ugrDestinationRow.ChildBands[0].Rows[newIndex].Activate();
                        }

                        DeleteRow(ugrSourceRow);
                    }
                    else
                    {
                        isDestinationChildofSource = false;

                        MessageBox.Show("Incorrect hierarchy, operation not supported.", "Information");

                    }
                }



            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

        private void ultraGrid1_AfterCellUpdate(object sender, CellEventArgs e)
        {
            
        }
        private void ultraGrid1_AfterRowsDeleted(object sender, EventArgs e)
        {
            string str = "";
        }
        private void ultraGrid1_BeforeRowsDeleted(object sender, BeforeRowsDeletedEventArgs e)
        {
            string str = "";
        }

        private delegate void GridMethodDelegate(UltraGridRow grid);

        private void DeleteRow(UltraGridRow row)
        {
            row.Delete(false);

        }
      
        private bool IsSourceContainsDestination(DataClass childList, DataClass destListObject)
        {
            try
            {
                if (childList.Children.Contains(destListObject))
                {
                    isDestinationChildofSource = true;
                }
                else
                {
                    foreach (DataClass childListObject in childList.Children)
                    {
                        if (childListObject.Children.Contains(destListObject))
                        {
                            isDestinationChildofSource = true;
                            break;
                        }
                        else
                        {
                            isDestinationChildofSource = IsSourceContainsDestination(childListObject, destListObject);
                        }


                    }
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return isDestinationChildofSource;
        }
        #endregion

       
      

       

    }
}
